#include <iostream>
#include <vector>
using namespace std;

int main() {
	int nn;
	cin >> nn;
	vector<int> dane(nn);
	for(int i = 0; i < nn; i++) {
		cin >> dane[i];
		if(dane[i] > i) {
			cout << "NIE\n";
			return 0;
		}
	}
	
	vector<int> tt; 
	for (int i = 0; i < nn; i++) {
		tt.insert(tt.begin() + i - dane[i], i);
	}
	vector<int> odp(nn, 0);
	for(int i = 0; i < nn; i++) 
		odp[tt[i]] = i + 1;
	for(int i : odp) 
		cout << i << " ";
	cout << endl;
	return 0;
}
